package ru.dbotthepony.mc.otm.datagen.loot

import ru.dbotthepony.mc.otm.registry.MBlocks
import ru.dbotthepony.mc.otm.registry.MRegistry

private val workerTags = arrayOf(
	TileNbtCopy("work_ticks"),
	TileNbtCopy("current_job"),
	TileNbtCopy("battery_container"),
	TileNbtCopy("energy"),
)

fun addLootTables(lootTables: LootTables) {
	lootTables.dropsSelf(MBlocks.CRATE_LIST)

	lootTables.dropsSelf(MRegistry.CARGO_CRATES.blocks)
	lootTables.dropsSelf(MRegistry.INDUSTRIAL_GLASS.blocks)
	lootTables.dropsSelf(MRegistry.INDUSTRIAL_GLASS_PANE.blocks)
	lootTables.dropsSelf(MRegistry.TRITANIUM_BLOCK.blocks)
	lootTables.dropsSelf(MRegistry.VENT.blocks)
	lootTables.dropsSelf(MRegistry.VENT_ALTERNATIVE.blocks)
	lootTables.dropsSelf(MRegistry.FLOOR_TILES.coloredBlocks)
	lootTables.dropsSelf(MRegistry.UNREFINED_FLOOR_TILES.coloredBlocks)
	lootTables.dropsSelf(MRegistry.TRITANIUM_STRIPED_BLOCK.blocks)

	lootTables.dropsSelf(MBlocks.CARBON_FIBRE_BLOCK)
	lootTables.dropsSelf(MBlocks.TRITANIUM_RAW_BLOCK)
	lootTables.dropsSelf(MBlocks.TRITANIUM_STRIPED_BLOCK)
	lootTables.dropsSelf(MBlocks.MATTER_CABLE)
	lootTables.dropsSelf(MBlocks.GRAVITATION_STABILIZER)

	lootTables.tile(MBlocks.ENERGY_COUNTER, TileNbtCopy("passed"), TileNbtCopy("history"), TileNbtCopy("history_tick"))
	lootTables.tile(MBlocks.CHEMICAL_GENERATOR, TileNbtCopy("energy"), TileNbtCopy("container"), TileNbtCopy("working_ticks"), TileNbtCopy("working_ticks_total"))

	lootTables.tile(MBlocks.ANDROID_STATION, TileNbtCopy("energy"), TileNbtCopy("battery_container"))
	lootTables.tile(MBlocks.BATTERY_BANK, TileNbtCopy("container"))
	lootTables.tile(MBlocks.DRIVE_VIEWER, TileNbtCopy("energy"), TileNbtCopy("container"), TileNbtCopy("battery_container"))

	lootTables.tile(MBlocks.STORAGE_BUS, TileNbtCopy("energy"), TileNbtCopy("battery_container"))
	lootTables.tile(MBlocks.STORAGE_IMPORTER, TileNbtCopy("energy"), TileNbtCopy("battery_container"))
	lootTables.tile(MBlocks.STORAGE_POWER_SUPPLIER, TileNbtCopy("energy"), TileNbtCopy("battery_container"), TileNbtCopy("power_supplied"))

	lootTables.tile(MBlocks.MATTER_DECOMPOSER, TileNbtCopy("container"), TileNbtCopy("matter"), *workerTags)
	lootTables.tile(MBlocks.MATTER_REPLICATOR, TileNbtCopy("container"), TileNbtCopy("matter"), *workerTags)
	lootTables.tile(MBlocks.MATTER_RECYCLER, TileNbtCopy("container"), TileNbtCopy("matter"), *workerTags)
	lootTables.tile(MBlocks.MATTER_SCANNER, TileNbtCopy("container"), *workerTags)
	lootTables.tile(MBlocks.PLATE_PRESS, TileNbtCopy("container"), *workerTags)

	lootTables.tile(MBlocks.MATTER_PANEL, TileNbtCopy("tasks"))
	lootTables.tile(MBlocks.PATTERN_STORAGE, TileNbtCopy("patterns"))
	lootTables.tile(MBlocks.MATTER_CAPACITOR_BANK, TileNbtCopy("container"))
	lootTables.tile(MBlocks.MATTER_BOTTLER, TileNbtCopy("energy"), TileNbtCopy("battery_container"), TileNbtCopy("work_slots"), TileNbtCopy("work_flow"), TileNbtCopy("matter"))
}
