package ru.dbotthepony.mc.otm.registry;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.recipe.PlatePressRecipe;
import ru.dbotthepony.mc.otm.recipe.PlatePressRecipeFactory;

public class MRecipes {
	public static class MatteryRecipeType<T extends Recipe<?>> implements RecipeType<T> {
		public final ResourceLocation name;

		private MatteryRecipeType(ResourceLocation name) {
			this.name = name;
		}

		@Override
		public String toString() {
			return name.toString();
		}
	}

	public static final MatteryRecipeType<PlatePressRecipe> PLATE_PRESS = new MatteryRecipeType<>(OverdriveThatMatters.loc(MNames.PLATE_PRESS));

	private static final DeferredRegister<RecipeSerializer<?>> registry = DeferredRegister.create(ForgeRegistries.RECIPE_SERIALIZERS, OverdriveThatMatters.MOD_ID);
	private static final DeferredRegister<RecipeType<?>> typesRegistry = DeferredRegister.create(ForgeRegistries.RECIPE_TYPES, OverdriveThatMatters.MOD_ID);

	static {
		registry.register(MNames.PLATE_PRESS, () -> PlatePressRecipeFactory.INSTANCE);
		typesRegistry.register(MNames.PLATE_PRESS, () -> PLATE_PRESS);
	}

	public static void register(IEventBus bus) {
		registry.register(bus);
		typesRegistry.register(bus);
	}
}
