package ru.dbotthepony.mc.otm.client.screen.panels

import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

open class DraggableCanvasPanel @JvmOverloads constructor(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 10f,
	height: Float = 10f
) : EditablePanel(
	screen, parent, x, y, width, height
) {
	protected var dragging = false

	override fun mouseClickedInner(x: Double, y: Double, button: Int): Boolean {
		dragging = true
		trapMouseInput = true
		return true
	}

	override fun mouseReleasedInner(x: Double, y: Double, button: Int): Boolean {
		dragging = false
		trapMouseInput = false
		return true
	}

	override fun mouseDraggedInner(x: Double, y: Double, button: Int, xDelta: Double, yDelta: Double): Boolean {
		if (dragging) {
			xOffset += xDelta.toFloat()
			yOffset += yDelta.toFloat()
		}

		return true
	}

	init {
		scissor = true
	}
}