package ru.dbotthepony.mc.otm.client.screen.panels

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen
import net.minecraft.client.gui.screens.inventory.InventoryScreen
import net.minecraft.world.entity.LivingEntity
import ru.dbotthepony.mc.otm.client.render.element
import ru.dbotthepony.mc.otm.client.screen.ExoSuitInventoryScreen
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

private fun calculateScale(width: Float, height: Float): Int {
	val aspectRatio = width / height

	if (aspectRatio.isNaN()) {
		return 1
	}

	if (aspectRatio < 0.7083) {
		return (width / 51f * 30f).toInt()
	} else {
		return (height / 72f * 30f).toInt()
	}
}

class EntityRendererPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	val entity: LivingEntity,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = ENTITY_RECTANGLE.w,
	height: Float = ENTITY_RECTANGLE.h,
	var renderScale: Int = calculateScale(width, height)
) : EditablePanel(screen, parent, x, y, width, height) {
	override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
		ExoSuitInventoryScreen.ENTITY_RECTANGLE.render(stack)

		if (entity.isDeadOrDying) {
			return
		}

		val renderX = absoluteX.toInt() + width.toInt() / 2
		val renderY = absoluteY.toInt() + (height * 0.9f).toInt()

		InventoryScreen.renderEntityInInventory(
			renderX,
			renderY,
			renderScale,
			renderX - mouseX,
			absoluteY + height * 0.15f - mouseY,
			entity
		)
	}

	companion object {
		val ENTITY_RECTANGLE = AbstractContainerScreen.INVENTORY_LOCATION.element(25f, 7f, 51f, 72f)
	}
}
