package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import ru.dbotthepony.mc.otm.core.ImmutableList
import ru.dbotthepony.mc.otm.block.entity.CargoCrateBlockEntity
import ru.dbotthepony.mc.otm.registry.MMenus

class CargoCrateMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: CargoCrateBlockEntity? = null
) : MatteryMenu(MMenus.CARGO_CRATE, p_38852_, inventory, tile) {
	override val storageSlots: List<MatterySlot>

	init {
		val container = tile?.container ?: SimpleContainer(CargoCrateBlockEntity.CAPACITY)

		storageSlots = ImmutableList(CargoCrateBlockEntity.CAPACITY) {
			val slot = MatterySlot(container, it)
			addSlot(slot)
			return@ImmutableList slot
		}

		tile?.onPlayerOpen()
		addInventorySlots()
	}

	override fun removed(p_38940_: Player) {
		super.removed(p_38940_)
		(tile as? CargoCrateBlockEntity)?.onPlayerClose()
	}
}
