package ru.dbotthepony.mc.otm.menu

import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.matter.MatterScannerBlockEntity
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import net.minecraft.world.SimpleContainer
import net.minecraft.world.inventory.Slot
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.core.ImpreciseFraction
import ru.dbotthepony.mc.otm.matter.canDecompose
import ru.dbotthepony.mc.otm.registry.MMenus
import java.math.BigInteger

class MatterScannerMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: MatterScannerBlockEntity? = null
) : MatteryPoweredMenu(
	MMenus.MATTER_SCANNER, p_38852_, inventory, tile
) {
	val input: MatterySlot
	val progress: ProgressGaugeWidget
	val patterns: LevelGaugeWidget

	init {
		val container = tile?.container ?: SimpleContainer(1)

		input = object : MatterySlot(container, 0, 64, 38) {
			override fun mayPlace(p_40231_: ItemStack): Boolean {
				return canDecompose(p_40231_)
			}
		}

		addSlot(input)

		if (tile != null) {
			progress = ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess)
			patterns = LevelGaugeWidget(this,
				{ ImpreciseFraction(tile.matterGraph?.patternCount ?: 0L) },
				{ ImpreciseFraction(tile.matterGraph?.patternCapacity ?: 0L) })
		} else {
			progress = ProgressGaugeWidget(this)
			patterns = LevelGaugeWidget(this)
		}

		addInventorySlots()
	}

	override val storageSlots: List<MatterySlot> = listOf(input)
}
